# Criteo API SDK for Python

## Introduction
API Client Libraries can facilitate your use of the Criteo API allowing you to build unique and customized solutions to serve your businesses and clients.
These libraries can reduce the amount of code you need to write in order to start accessing Criteo programmatically. They also can help expedite troubleshooting, should you encounter any issues.

More information: [https://developers.criteo.com/](https://developers.criteo.com/)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- Package version: 2023.04.0.230831

## Requirements

Python 2.7 and 3.5+

## Installation & Usage
### pip install

```sh
pip install criteo-api-retailmedia-sdk==2023.04.0.230831
```
(you may need to run `pip` with root permission: `sudo pip install criteo-api-retailmedia-sdk==2023.04.0.230831`)

Then import the package:
```python
import criteo_api_retailmedia_v2023_04
```

### Manual Installation using [Setuptools](http://pypi.python.org/pypi/setuptools)

Download the code or clone the repository locally, then execute the following command:

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import criteo_api_retailmedia_v2023_04
```

## Example
There are multiple examples for the different OAuth flows that the SDK supports.
- See [test/example_application_with_client_credentials.py](test/example_application_with_client_credentials.py) for an example with Client Credentials.
- See [test/example_application_with_auth_code.py](test/example_application_with_auth_code.py) for an example with Authorization Code.
Once you follow the authorization code flow, you will have a refresh token that has to be used to regenerate access token for future usage. 
    - See [test/example_application_with_refresh_token.py](test/example_application_with_refresh_token.py) for an example with Refresh Token .

## Documentation for API Endpoints

The developers documentation is available at: *https://developers.criteo.com*.

All URIs are relative to *https://api.criteo.com*.

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------


## Documentation For Models

 - [AddToBasketIdsUpdateModel202110Request](docs/AddToBasketIdsUpdateModel202110Request.md)
 - [AddToBasketTarget202110Request](docs/AddToBasketTarget202110Request.md)
 - [AddToBasketTarget202110Response](docs/AddToBasketTarget202110Response.md)
 - [ApplicationSummaryModel](docs/ApplicationSummaryModel.md)
 - [ApplicationSummaryModelResource](docs/ApplicationSummaryModelResource.md)
 - [ApplicationSummaryModelResponse](docs/ApplicationSummaryModelResponse.md)
 - [Asset](docs/Asset.md)
 - [AssetResource](docs/AssetResource.md)
 - [AssetResponse](docs/AssetResponse.md)
 - [AuctionLineItemCreateModelRequest](docs/AuctionLineItemCreateModelRequest.md)
 - [AuctionLineItemPagedListResponse](docs/AuctionLineItemPagedListResponse.md)
 - [AuctionLineItemResponse](docs/AuctionLineItemResponse.md)
 - [AuctionLineItemUpdateModelRequest](docs/AuctionLineItemUpdateModelRequest.md)
 - [AudienceIdsUpdateModel202110Request](docs/AudienceIdsUpdateModel202110Request.md)
 - [AudienceTarget202110Request](docs/AudienceTarget202110Request.md)
 - [AudienceTarget202110Response](docs/AudienceTarget202110Response.md)
 - [BadRequest](docs/BadRequest.md)
 - [Balance202110PagedListResponse](docs/Balance202110PagedListResponse.md)
 - [BalanceCampaign202110ListRequest](docs/BalanceCampaign202110ListRequest.md)
 - [BalanceCampaign202110PagedListResponse](docs/BalanceCampaign202110PagedListResponse.md)
 - [CampaignAttributesV202301](docs/CampaignAttributesV202301.md)
 - [CampaignV202301](docs/CampaignV202301.md)
 - [Category202204](docs/Category202204.md)
 - [Category202204ListResponse](docs/Category202204ListResponse.md)
 - [ChoiceOption](docs/ChoiceOption.md)
 - [ChoiceVariableSpecification](docs/ChoiceVariableSpecification.md)
 - [ChoiceVariableValue](docs/ChoiceVariableValue.md)
 - [ColorVariableValue](docs/ColorVariableValue.md)
 - [CommonError](docs/CommonError.md)
 - [CommonLineItemPagedListResponse](docs/CommonLineItemPagedListResponse.md)
 - [CommonLineItemResponse](docs/CommonLineItemResponse.md)
 - [CommonProblem](docs/CommonProblem.md)
 - [CommonStatusCodeResponse](docs/CommonStatusCodeResponse.md)
 - [CommonWarning](docs/CommonWarning.md)
 - [CreateRetailMediaAudience](docs/CreateRetailMediaAudience.md)
 - [CreateRetailMediaAudienceAttributes](docs/CreateRetailMediaAudienceAttributes.md)
 - [CreateRetailMediaAudienceBody](docs/CreateRetailMediaAudienceBody.md)
 - [CreateRetailMediaAudienceRequest](docs/CreateRetailMediaAudienceRequest.md)
 - [CreateRetailMediaAudienceResponse](docs/CreateRetailMediaAudienceResponse.md)
 - [CreateRetailMediaAudienceV2](docs/CreateRetailMediaAudienceV2.md)
 - [CreateRetailMediaAudienceV2Attributes](docs/CreateRetailMediaAudienceV2Attributes.md)
 - [CreateRetailMediaAudienceV2Data](docs/CreateRetailMediaAudienceV2Data.md)
 - [CreateRetailMediaAudienceV2Request](docs/CreateRetailMediaAudienceV2Request.md)
 - [CreateUserBehaviorSegmentV2](docs/CreateUserBehaviorSegmentV2.md)
 - [Creative202110](docs/Creative202110.md)
 - [Creative202110ListResponse](docs/Creative202110ListResponse.md)
 - [Creative202210](docs/Creative202210.md)
 - [Creative202210ListResponse](docs/Creative202210ListResponse.md)
 - [Creative202210Response](docs/Creative202210Response.md)
 - [CreativeCreateModel202207](docs/CreativeCreateModel202207.md)
 - [CreativeUpdateModel202207](docs/CreativeUpdateModel202207.md)
 - [CustomerListDetails](docs/CustomerListDetails.md)
 - [EditableCampaignAttributesV202301](docs/EditableCampaignAttributesV202301.md)
 - [EnvelopeReportRequest](docs/EnvelopeReportRequest.md)
 - [EnvelopeReportStatus](docs/EnvelopeReportStatus.md)
 - [Error](docs/Error.md)
 - [ExternalAccount](docs/ExternalAccount.md)
 - [ExternalAddToBasketIdsUpdateModel202110](docs/ExternalAddToBasketIdsUpdateModel202110.md)
 - [ExternalAddToBasketTarget202110](docs/ExternalAddToBasketTarget202110.md)
 - [ExternalAuctionLineItem](docs/ExternalAuctionLineItem.md)
 - [ExternalAuctionLineItemCreateModel](docs/ExternalAuctionLineItemCreateModel.md)
 - [ExternalAuctionLineItemUpdateModel](docs/ExternalAuctionLineItemUpdateModel.md)
 - [ExternalAudienceIdsUpdateModel202110](docs/ExternalAudienceIdsUpdateModel202110.md)
 - [ExternalAudienceTarget202110](docs/ExternalAudienceTarget202110.md)
 - [ExternalBalance202110](docs/ExternalBalance202110.md)
 - [ExternalBrand](docs/ExternalBrand.md)
 - [ExternalCatalogRequest](docs/ExternalCatalogRequest.md)
 - [ExternalCatalogStatus](docs/ExternalCatalogStatus.md)
 - [ExternalCommonLineItem](docs/ExternalCommonLineItem.md)
 - [ExternalKeywordTarget202110](docs/ExternalKeywordTarget202110.md)
 - [ExternalLineItemCapping202110](docs/ExternalLineItemCapping202110.md)
 - [ExternalLineItemPage202110](docs/ExternalLineItemPage202110.md)
 - [ExternalLineItemPageCategory202110](docs/ExternalLineItemPageCategory202110.md)
 - [ExternalPreferredLineItem202110](docs/ExternalPreferredLineItem202110.md)
 - [ExternalPreferredLineItemCreateModel202110](docs/ExternalPreferredLineItemCreateModel202110.md)
 - [ExternalPreferredLineItemUpdateModel202110](docs/ExternalPreferredLineItemUpdateModel202110.md)
 - [ExternalPromotedProduct202110](docs/ExternalPromotedProduct202110.md)
 - [ExternalRetailer](docs/ExternalRetailer.md)
 - [ExternalRetailerPages202110](docs/ExternalRetailerPages202110.md)
 - [ExternalStoreIdsUpdateModel202110](docs/ExternalStoreIdsUpdateModel202110.md)
 - [ExternalStoreTarget202110](docs/ExternalStoreTarget202110.md)
 - [FilesVariableValue](docs/FilesVariableValue.md)
 - [FilesVariablesSpecification](docs/FilesVariablesSpecification.md)
 - [GetPageOfAudiencesByAccountIdResponse](docs/GetPageOfAudiencesByAccountIdResponse.md)
 - [HyperlinkVariableValue](docs/HyperlinkVariableValue.md)
 - [InputResourceOfAuctionLineItemCreateModel](docs/InputResourceOfAuctionLineItemCreateModel.md)
 - [InputResourceOfPreferredLineItemCreateModel202110](docs/InputResourceOfPreferredLineItemCreateModel202110.md)
 - [JsonApiBodyWithExternalIdOfEditableCampaignAttributesV202301AndCampaignV202301](docs/JsonApiBodyWithExternalIdOfEditableCampaignAttributesV202301AndCampaignV202301.md)
 - [JsonApiBodyWithIdOfInt64AndAccountAndAccount](docs/JsonApiBodyWithIdOfInt64AndAccountAndAccount.md)
 - [JsonApiBodyWithIdOfInt64AndBrandAndBrand](docs/JsonApiBodyWithIdOfInt64AndBrandAndBrand.md)
 - [JsonApiBodyWithIdOfInt64AndCampaignV202301AndCampaignV202301](docs/JsonApiBodyWithIdOfInt64AndCampaignV202301AndCampaignV202301.md)
 - [JsonApiBodyWithIdOfInt64AndCatalogStatusAndCatalogStatus](docs/JsonApiBodyWithIdOfInt64AndCatalogStatusAndCatalogStatus.md)
 - [JsonApiBodyWithIdOfInt64AndLineItemBidMultipliersAndLineItemBidMultipliers](docs/JsonApiBodyWithIdOfInt64AndLineItemBidMultipliersAndLineItemBidMultipliers.md)
 - [JsonApiBodyWithIdOfInt64AndRetailerAndRetailer](docs/JsonApiBodyWithIdOfInt64AndRetailerAndRetailer.md)
 - [JsonApiBodyWithoutIdOfCampaignAttributesV202301AndCampaignV202301](docs/JsonApiBodyWithoutIdOfCampaignAttributesV202301AndCampaignV202301.md)
 - [JsonApiBodyWithoutIdOfCatalogRequestAndCatalogRequest](docs/JsonApiBodyWithoutIdOfCatalogRequestAndCatalogRequest.md)
 - [JsonApiPageResponseOfAccount](docs/JsonApiPageResponseOfAccount.md)
 - [JsonApiPageResponseOfBrand](docs/JsonApiPageResponseOfBrand.md)
 - [JsonApiPageResponseOfCampaignV202301](docs/JsonApiPageResponseOfCampaignV202301.md)
 - [JsonApiPageResponseOfRetailer](docs/JsonApiPageResponseOfRetailer.md)
 - [JsonApiRequestOfCatalogRequest](docs/JsonApiRequestOfCatalogRequest.md)
 - [JsonApiSingleResponseOfCampaignV202301](docs/JsonApiSingleResponseOfCampaignV202301.md)
 - [JsonApiSingleResponseOfCatalogStatus](docs/JsonApiSingleResponseOfCatalogStatus.md)
 - [JsonApiSingleResponseOfLineItemBidMultipliers](docs/JsonApiSingleResponseOfLineItemBidMultipliers.md)
 - [KeywordTarget202110Request](docs/KeywordTarget202110Request.md)
 - [KeywordTarget202110Response](docs/KeywordTarget202110Response.md)
 - [LineItemBidMultipliers](docs/LineItemBidMultipliers.md)
 - [LineItemBidMultipliersRequest](docs/LineItemBidMultipliersRequest.md)
 - [LineItemBidMultipliersResponse](docs/LineItemBidMultipliersResponse.md)
 - [MapString](docs/MapString.md)
 - [PageMetadata](docs/PageMetadata.md)
 - [PageTypeEnvironment](docs/PageTypeEnvironment.md)
 - [PostCampaignV202301](docs/PostCampaignV202301.md)
 - [PreferredLineItem202110PagedListResponse](docs/PreferredLineItem202110PagedListResponse.md)
 - [PreferredLineItem202110Response](docs/PreferredLineItem202110Response.md)
 - [PreferredLineItemCreateModel202110Request](docs/PreferredLineItemCreateModel202110Request.md)
 - [PreferredLineItemUpdateModel202110Request](docs/PreferredLineItemUpdateModel202110Request.md)
 - [ProblemDetails](docs/ProblemDetails.md)
 - [PromotedProduct202110ListRequest](docs/PromotedProduct202110ListRequest.md)
 - [PromotedProduct202110PagedListResponse](docs/PromotedProduct202110PagedListResponse.md)
 - [PutCampaignV202301](docs/PutCampaignV202301.md)
 - [ReportRequest](docs/ReportRequest.md)
 - [ReportRequestAttributes](docs/ReportRequestAttributes.md)
 - [ReportStatus](docs/ReportStatus.md)
 - [ReportStatusAttributes](docs/ReportStatusAttributes.md)
 - [ResourceOfAuctionLineItem](docs/ResourceOfAuctionLineItem.md)
 - [ResourceOfAuctionLineItemUpdateModel](docs/ResourceOfAuctionLineItemUpdateModel.md)
 - [ResourceOfBalance202110](docs/ResourceOfBalance202110.md)
 - [ResourceOfBalanceCampaign202110](docs/ResourceOfBalanceCampaign202110.md)
 - [ResourceOfCategory202204](docs/ResourceOfCategory202204.md)
 - [ResourceOfCommonLineItem](docs/ResourceOfCommonLineItem.md)
 - [ResourceOfCreative202110](docs/ResourceOfCreative202110.md)
 - [ResourceOfCreative202210](docs/ResourceOfCreative202210.md)
 - [ResourceOfLineItemBidMultipliers](docs/ResourceOfLineItemBidMultipliers.md)
 - [ResourceOfPreferredLineItem202110](docs/ResourceOfPreferredLineItem202110.md)
 - [ResourceOfPreferredLineItemUpdateModel202110](docs/ResourceOfPreferredLineItemUpdateModel202110.md)
 - [ResourceOfPromotedProduct202110](docs/ResourceOfPromotedProduct202110.md)
 - [ResourceOfTemplate](docs/ResourceOfTemplate.md)
 - [RetailMediaAudience](docs/RetailMediaAudience.md)
 - [RetailMediaAudienceAttributes](docs/RetailMediaAudienceAttributes.md)
 - [RetailMediaAudienceV2](docs/RetailMediaAudienceV2.md)
 - [RetailMediaAudienceV2Attributes](docs/RetailMediaAudienceV2Attributes.md)
 - [RetailMediaAudienceV2ListResponse](docs/RetailMediaAudienceV2ListResponse.md)
 - [RetailMediaAudienceV2Response](docs/RetailMediaAudienceV2Response.md)
 - [RetailMediaExternalv1AddRemoveKeywordModel](docs/RetailMediaExternalv1AddRemoveKeywordModel.md)
 - [RetailMediaExternalv1AddRemoveKeywordsModel](docs/RetailMediaExternalv1AddRemoveKeywordsModel.md)
 - [RetailMediaExternalv1AddRemoveKeywordsModelRequest](docs/RetailMediaExternalv1AddRemoveKeywordsModelRequest.md)
 - [RetailMediaExternalv1AddRemoveKeywordsModelResource](docs/RetailMediaExternalv1AddRemoveKeywordsModelResource.md)
 - [RetailMediaExternalv1InputKeywordsModel](docs/RetailMediaExternalv1InputKeywordsModel.md)
 - [RetailMediaExternalv1KeywordDataModel](docs/RetailMediaExternalv1KeywordDataModel.md)
 - [RetailMediaExternalv1KeywordsModel](docs/RetailMediaExternalv1KeywordsModel.md)
 - [RetailMediaExternalv1KeywordsModelResource](docs/RetailMediaExternalv1KeywordsModelResource.md)
 - [RetailMediaExternalv1KeywordsModelResponse](docs/RetailMediaExternalv1KeywordsModelResponse.md)
 - [RetailMediaExternalv1ProblemDetails](docs/RetailMediaExternalv1ProblemDetails.md)
 - [RetailMediaExternalv1ProposalStatusModel](docs/RetailMediaExternalv1ProposalStatusModel.md)
 - [RetailMediaExternalv1ProposalStatusModelResource](docs/RetailMediaExternalv1ProposalStatusModelResource.md)
 - [RetailMediaExternalv1ProposalStatusModelResponse](docs/RetailMediaExternalv1ProposalStatusModelResponse.md)
 - [RetailMediaExternalv1ResourceOutcome](docs/RetailMediaExternalv1ResourceOutcome.md)
 - [RetailMediaExternalv1SetBidModel](docs/RetailMediaExternalv1SetBidModel.md)
 - [RetailMediaExternalv1SetBidsModel](docs/RetailMediaExternalv1SetBidsModel.md)
 - [RetailMediaExternalv1SetBidsModelRequest](docs/RetailMediaExternalv1SetBidsModelRequest.md)
 - [RetailMediaExternalv1SetBidsModelResource](docs/RetailMediaExternalv1SetBidsModelResource.md)
 - [Section](docs/Section.md)
 - [StoreIdsUpdateModel202110Request](docs/StoreIdsUpdateModel202110Request.md)
 - [StoreTarget202110Request](docs/StoreTarget202110Request.md)
 - [StoreTarget202110Response](docs/StoreTarget202110Response.md)
 - [Template](docs/Template.md)
 - [TemplateListResponse](docs/TemplateListResponse.md)
 - [TemplateResponse](docs/TemplateResponse.md)
 - [TemplateVariable](docs/TemplateVariable.md)
 - [TemplateVariableValue](docs/TemplateVariableValue.md)
 - [TextVariableSpecification](docs/TextVariableSpecification.md)
 - [TextVariableValue](docs/TextVariableValue.md)
 - [UserBehaviorDetails](docs/UserBehaviorDetails.md)
 - [UserBehaviorDetailsV2](docs/UserBehaviorDetailsV2.md)
 - [ValueTypeResourceOfAddToBasketIdsUpdateModel202110](docs/ValueTypeResourceOfAddToBasketIdsUpdateModel202110.md)
 - [ValueTypeResourceOfAddToBasketTarget202110](docs/ValueTypeResourceOfAddToBasketTarget202110.md)
 - [ValueTypeResourceOfAudienceIdsUpdateModel202110](docs/ValueTypeResourceOfAudienceIdsUpdateModel202110.md)
 - [ValueTypeResourceOfAudienceTarget202110](docs/ValueTypeResourceOfAudienceTarget202110.md)
 - [ValueTypeResourceOfKeywordTarget202110](docs/ValueTypeResourceOfKeywordTarget202110.md)
 - [ValueTypeResourceOfStoreIdsUpdateModel202110](docs/ValueTypeResourceOfStoreIdsUpdateModel202110.md)
 - [ValueTypeResourceOfStoreTarget202110](docs/ValueTypeResourceOfStoreTarget202110.md)


## Disclaimer

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.